Subject: Re: Git mirror at gitlab

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 21 Mar 2024 12:24:46 +0100

On Wed, Jan 17, 2024 at 07:35:55AM +0100, Patrick Steinhardt wrote:
> On Thu, Dec 21, 2023 at 12:48:12PM +0100, Patrick Steinhardt wrote:
> > On Thu, Dec 21, 2023 at 12:30:02PM +0100, Olliver Schinagl wrote:
> > > Hey list,
> > > 
> > > For years, I wanted (tried, but time) to run the mirror for git on gitlab.
> > > Actually, the original idea was to run a docker container ([0] 10k+ pulls
> > > :p)
> > > 
> > > I initially set this up via docker build containers, where docker hub would
> > > pull my mirror of the git repo. My mirror, because I added a Dockerfile
> > > which was enough for docker to do its trick. I was planning (time ..) on
> > > submitting this upstream to the list, but never did. Because of me not doing
> > > that, I had to manually (I was even too lazy to script it) rebase the
> > > branch. Docker then did some changes to their business, where the docker
> > > builds where not possible anymore.
> > > 
> > > So then I figured, I'll do the same on gitlab and push it to the docker hub.
> > > Thus I setup a mirror on gitlab [1], with the idea to work there on it.
> > > 
> > > Again, I never got around to finalize this work, mostly because the docker
> > > container 'just worked' for pretty much everything. After all, git is very
> > > stable overal.
> > > 
> > > So very interestingly, last month commit 0e3b67e2aa25edb ("ci: add support
> > > for GitLab CI") landed, which started to trigger pipeline jobs!
> > > 
> > > Sadly, this only worked for 3 builds, as that's when the minutes ran out :)
> > > 
> > > So one, I would very much like to offer the registered names (cause they are
> > > pretty nice in name) to here, so people can use and find it.
> > 
> > Not to throw a wrench into this, but are you aware of the official
> > GitLab mirror at https://gitlab.com/git-vcs/git? I myself wasn't aware
> > of this mirror for a rather long time.
> > 
> > I also wondered whether we want to have https://gitlab.com/git/git as we
> > do on GitHub. I don't think anybody registered it, but it is blocked
> > from being registered as far as I can tell. Maybe we block the namespace
> > out of caution, I dunno. I can certainly check in with our SREs in case
> > it is something the Git project would like to own.
> 
> Circling back on this topic: https://gitlab.com/git is unfortunately
> taken, so it's out of question. I'd say the most pragmatic thing to do
> would thus be to retain the already-existing location of the official
> mirror at GitLab.
> 
> I'm still trying to reach Ævar so that we can collaborate and set up CI
> for that mirror.
> 
> Patrick

I still have not been able to reach Ævar until now. Unless somebody else
has a way to contact him directly we at GitLab are wondering how to
continue. Two options:

  - Collaborate with our support folks at GitLab to add a new owner to
    the mirror. In theory we have this option, but none of us at GitLab
    feel that it is the right course of action. It feels too hostile and
    overreaching.

  - Set up a new official mirror hosted on GitLab and change the URLs
    that we advertise. We may want to use the one set up by Olliver
    (https://gitlab.com/gitscm/git), but in that case I'd want us to
    transfer ownership to people of the community that have been working
    on the project for a long time. We can also use an alternate URL,
    I'm happy to take proposals.

It would certainly be great to set up ownership of whatever solution we
arrive at such that it's more distributed across the community so that
we don't have a single point of failure in the future. Also, I don't
want us at GitLab to be the sole owners of the mirror, so I have been
wondering how the other mirrors are set up and whom we should add to any
such mirror.

In any case, once things are arranged I will collaborate with our
support folks to get free CI minutes for the new mirror.

Patrick